#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <wait.h>
#include <pthread.h>
#include <string.h>

#define bool int
#define true 1
#define false 0
#define print(...) do{printf(__VA_ARGS__); fflush(stdout); } while(0)

#define v_2 1

int buf_size = 1000;
int *buf;

bool nb_t = 3;
bool *starts;
int *vals;

pthread_mutex_t exclusive_lock;

bool cant_start() {
    bool start = true;
    for(int i=0; i<nb_t; i++) {
        if(starts[i] == false) start = false;
    }
    return start;
}

void buf_print(int val) {
    while(cant_start());

#ifdef v_2
    pthread_mutex_lock(&exclusive_lock);
#endif

    for(int i=0; i<1000; i++) {
        buf[i] = val;
        usleep(rand()%1000);
    }

#ifdef v_2
    pthread_mutex_unlock(&exclusive_lock);
#endif
}

void *create_t(void *ptr) {
    int index = ((int *)ptr)[0];

    int val = vals[index];
    starts[val] = true;

    buf_print(val);
    return 0;
}

int main() {
    pthread_mutex_init(&exclusive_lock, NULL);

    starts = malloc(sizeof(bool)*nb_t);
    vals = malloc(sizeof(int)*nb_t);

    buf = malloc(sizeof(int)*buf_size);

    int indexes[nb_t];
    pthread_t ts[nb_t];

    for(int i=0; i<nb_t; i++) {
        indexes[i] = i;
        starts[i] = false;
        vals[i] = 200+i*100;
        pthread_create(&(ts[i]), NULL, create_t, &(indexes[i]));
    }

    for(int i=0; i<nb_t; i++) pthread_join(ts[i], NULL);

    char *print_buf = malloc(sizeof(char) * (buf_size+buf_size*3));
    char *print_start = print_buf;

    for(int i=0; i<1000; i++) {
        sprintf(print_buf, "%d,", buf[i]);
        print_buf += 4;
    }
    print_start[buf_size+buf_size*3-1] = NULL;

    char *arr[4];
    arr[0] = "python3";
    arr[1] = "./../main.py";
    arr[2] = print_start;
    arr[3] = NULL;

    printf("%s", print_start);

    execvp(arr[0], arr);
}
